//
//  Print the contents of a file in hex-ASCII, the "debug-like" format.
//  Created                20-FEB-2001   Richard B. Johnson    
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>

#define BUF_LEN 0x1000

void hexdump(unsigned char *cp, size_t *offset, int len)
{
	int i;
	unsigned char c;
    while(len >= 0x10)
	{
         fprintf(stdout, "%08x %02x %02x %02x %02x %02x %02x %02x %02x-"\
			                  "%02x %02x %02x %02x %02x %02x %02x %02x ", 
			 *offset, cp[0], cp[1], cp[2],  cp[3],  cp[4],  cp[5],  cp[6],  cp[7],
			          cp[8], cp[9], cp[10], cp[11], cp[12], cp[13], cp[14], cp[15]);
		 for(i=0; i< 0x10; i++)
		 {
			 c = *cp++;
			 if (c < ' ' || c > 'z')
				 c = '.';
			 fprintf(stdout,"%c", c);
		 }
		 fprintf(stdout,"\n");
		 len     -= 0x10;
		 *offset += 0x10;
	}
	if(len)
	{
		fprintf(stdout, "%08x ", offset);
		for(i=0; i< len; i++)
			fprintf(stdout, "%02x ", cp[i]);
         for(i=0; i< 0x10; i++)
		 {
			 c = *cp++;
			 if (c < ' ' || c > 'z')
				 c = '.';
			 fprintf(stdout,"%c", c);
		 }
		 fprintf(stdout,"\n");
	}

}


int main(int args, char *argv[])
{

    
	int fd, val;
	size_t offset;
	unsigned char *cp;
	char *lf;
    if((cp = malloc(BUF_LEN))== NULL)
	{
		fprintf(stderr, "Memory allocation failure\n");
		exit(EXIT_FAILURE);
	}
	if(args < 2)
	{
	
        fprintf(stderr, "Enter filename : ");
		fgets(cp, BUF_LEN, stdin);
		if((lf = strchr(cp, '\n')) != NULL)
			*lf = (char) 0x00;
	}
	else
		strcpy(cp, argv[1]);
	if((fd = open(cp, O_RDONLY|O_BINARY)) < 0)
	{
		fprintf(stderr, "Can't open file %s for reading\n", cp);
		free(cp);
		exit(EXIT_FAILURE);
	}
	offset = 0;
    while((val = read(fd, cp, 0x100)) > 0)
	{
	    hexdump(cp, &offset, val);
		fprintf(stderr, "Continue...");
		fgets(cp, BUF_LEN, stdin);
	}
	fprintf(stderr, "[Enter] to exit ");
	fgets(cp, BUF_LEN, stdin);
    free(cp);
    (void)close(fd);
    return 0;
}
